require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__X86_64_MMU_CONTEXT_H)) {
    eval 'sub __X86_64_MMU_CONTEXT_H {1;}' unless defined(&__X86_64_MMU_CONTEXT_H);
    require 'linux/config.ph';
    require 'asm/desc.ph';
    require 'asm/atomic.ph';
    require 'asm/pgalloc.ph';
    require 'asm/pda.ph';
    require 'asm/pgtable.ph';
    require 'asm/tlbflush.ph';
    if(defined(&CONFIG_SMP)) {
	eval 'sub enter_lazy_tlb {
	    local($mm,$tsk) = @_;
    	    eval q({  &if ( &read_pda( &mmu_state) ==  &TLBSTATE_OK)  &write_pda( &mmu_state,  &TLBSTATE_LAZY); });
	}' unless defined(&enter_lazy_tlb);
    } else {
	eval 'sub enter_lazy_tlb {
	    local($mm,$tsk) = @_;
    	    eval q({ });
	}' unless defined(&enter_lazy_tlb);
    }
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub switch_mm {
        local($prev,$next,$tsk) = @_;
	    eval q({ \'unsigned cpu\' =  &smp_processor_id();  &if ( &likely($prev != $next)) {  &clear_bit( &cpu,  ($prev->{cpu_vm_mask}));  &set_bit( &cpu,  ($next->{cpu_vm_mask})); * &read_pda( &level4_pgt) =  &__pa( ($next->{pgd})) |  &_PAGE_TABLE;  &__flush_tlb();  &if ( &unlikely( ($next->{context}->{ldt}) !=  ($prev->{context}->{ldt})))  &load_LDT_nolock( ($next->{context}),  &cpu); } });
    }' unless defined(&switch_mm);
    eval 'sub deactivate_mm {
        local($tsk,$mm) = @_;
	    eval q( &do {  &load_gs_index(0);  &asm  &volatile(\\"movl %0,%%fs\\"::\\"r\\"(0)); }  &while(0));
    }' unless defined(&deactivate_mm);
    eval 'sub activate_mm {
        local($prev, $next) = @_;
	    eval q( &switch_mm(($prev),($next), &NULL));
    }' unless defined(&activate_mm);
}
1;
