require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_X86_64_PGALLOC_H)) {
    eval 'sub _X86_64_PGALLOC_H {1;}' unless defined(&_X86_64_PGALLOC_H);
    require 'asm/processor.ph';
    require 'asm/fixmap.ph';
    require 'asm/pda.ph';
    require 'linux/threads.ph';
    require 'linux/mm.ph';
    eval 'sub pmd_populate_kernel {
        local($mm, $pmd, $pte) = @_;
	    eval q( &set_pmd($pmd,  &__pmd( &_PAGE_TABLE |  &__pa($pte))));
    }' unless defined(&pmd_populate_kernel);
    eval 'sub pgd_populate {
        local($mm, $pgd, $pmd) = @_;
	    eval q( &set_pgd($pgd,  &__pgd( &_PAGE_TABLE |  &__pa($pmd))));
    }' unless defined(&pgd_populate);
    eval 'sub pmd_populate {
        local($mm,$pmd,$pte) = @_;
	    eval q({  &set_pmd($pmd,  &__pmd( &_PAGE_TABLE | ( &page_to_pfn($pte) <<  &PAGE_SHIFT))); });
    }' unless defined(&pmd_populate);
    eval 'sub pmd_t {
        eval q(* &get_pmd( &void) { ( &pmd_t *) &get_zeroed_page( &GFP_KERNEL); });
    }' unless defined(&pmd_t);
    eval 'sub pmd_free {
        local($pmd) = @_;
	    eval q({  &BUG_ON($pmd & ( &PAGE_SIZE-1));  &free_page($pmd); });
    }' unless defined(&pmd_free);
    eval 'sub pmd_t {
        eval q(* &pmd_alloc_one (\'struct mm_struct\' * &mm, my $addr) { ( &pmd_t *) &get_zeroed_page( &GFP_KERNEL| &__GFP_REPEAT); });
    }' unless defined(&pmd_t);
    eval 'sub pgd_t {
        eval q(* &pgd_alloc (\'struct mm_struct\' * &mm) { ( &pgd_t *) &get_zeroed_page( &GFP_KERNEL| &__GFP_REPEAT); });
    }' unless defined(&pgd_t);
    eval 'sub pgd_free {
        local($pgd) = @_;
	    eval q({  &BUG_ON($pgd & ( &PAGE_SIZE-1));  &free_page($pgd); });
    }' unless defined(&pgd_free);
    eval 'sub pte_t {
        eval q(* &pte_alloc_one_kernel(\'struct mm_struct\' * &mm, my $address) { ( &pte_t *) &get_zeroed_page( &GFP_KERNEL| &__GFP_REPEAT); });
    }' unless defined(&pte_t);
    eval 'sub page {
        eval q(* &pte_alloc_one(\'struct mm_struct\' * &mm, my $address) {  &void * &p = ( &void *) &get_zeroed_page( &GFP_KERNEL| &__GFP_REPEAT);  &if (! &p)  &NULL;  &virt_to_page( &p); });
    }' unless defined(&page);
    eval 'sub pte_free {
        local($pte) = @_;
	    eval q({  &__free_page($pte); } );
    }' unless defined(&pte_free);
    eval 'sub __pte_free_tlb {
        local($tlb,$pte) = @_;
	    eval q( &tlb_remove_page(($tlb),($pte)));
    }' unless defined(&__pte_free_tlb);
    eval 'sub __pmd_free_tlb {
        local($tlb,$x) = @_;
	    eval q( &pmd_free($x));
    }' unless defined(&__pmd_free_tlb);
}
1;
